//
//  QihooSpeechRecognition.h
//  QihooSpeechRecognition
//
//  Created by yangyaoheng on 14-7-30.
//  Copyright (c) 2014年 yangyaoheng. All rights reserved.
//

//#import <Foundation/Foundation.h>
//#import <AVFoundation/AVFoundation.h>
//#import "QSpeechAudioRecorder.h"
#import "QRecognitionListener.h"


/*--------------------------------------------------
 协议(protocol)类似于java语言里的接口(interface)，定义了一组方法
 而不提供具体实现，只有那些“遵守”(conform to)或“采用”(adopt)了
 这些Protocol的类来给出自己的实现。
 --------------------------------------------------*/
//@protocol QihooSpeechRegRes <NSObject>
//@required -(void)ResFunc:(NSString*)resStr;
//@end

@interface QihooSpeechConfig : NSObject
@property (readwrite) BOOL mBUseEndPoint;
@property (readwrite) float  mSilMaxLenS;   //最长静音时间
@property (readwrite) float mSpeechEndSilLenS;
@end


@interface QihooSpeechRecognizer : NSObject{
    /*id是保存“指向对象的指针”的类型。*/
    id<QRecognitionListener>  _delegate;
    NSString *_appId;
    NSString *_securetKey;
    NSArray* _requestIdTable;
    NSString* _requestId;
    
    QihooSpeechConfig *_configer;
    //QSpeechService *_service;  //mv to .m file
    
    int _state; //
}




/*-------------------------------------------------------
 * 获取当前SDK的版本号
 * 静态函数
 ------------------------------------------------------*/
+(NSString*) getVersion;

/*retain只是保存其对象，并且其计数值+1*/
//@property (nonatomic, retain) id<QRecognitionListener>_delegate;
-(void)setDelegate:(id<QRecognitionListener>) delegate;

/*-------------------------------------------------------
 * 创建一个QihooSpeechRecognizer对象
 * 静态函数
 * 返回值：
 *      失败：NULL
 *      成功: 返回指向QihooSpeechRecognizer对象的指针
 ------------------------------------------------------*/
//+(QihooSpeechRecognizer*) createSpeechRecognizer:(NSString*) appid appSecret:(NSString*) appsec;

-(BOOL)initWithParam: (NSString*) id SecuretKey:(NSString*) key;

/*-------------------------------------------------------
 * 设置SDK的相关参数 （具体参数参照QihooSpeechConfig成员注释）
 * c=NULL 情况下，将采用默认参数
 ------------------------------------------------------*/
-(void) setConfig:(QihooSpeechConfig*) c;

/*-------------------------------------------------------
 * 设置回调函数，负责接收识别结果及错误
 ------------------------------------------------------*/
//-(void)setListener:(QRecognitionListener*) listener;

/*-------------------------------------------------------
 * 开始录音
 * 注意：在调用此函数前，确保已调用setListener。
 ------------------------------------------------------*/
-(void)startListening;

/*-------------------------------------------------------
 * 结束录音
 ------------------------------------------------------*/
-(void)stopListening;

/*-------------------------------------------------------
 * 取消录音
 ------------------------------------------------------*/
-(void)cancel;


//-(void)destory;



/*------------------------------------------------------------
 * 生成32位requstID
 * 格式
 *   ios-sdk_version-*****-****-****-****
 * 结果存放在_requestId中
 ------------------------------------------------------------*/
//-(void)genRequestId;

@end
